
//----------------------------------------------------------
// dijkstra
//   graph, start, "foot"|"car", is_goal?, weight?
//----------------------------------------------------------

function PriorityQueue(e)
{
	var Q = (e ? [e] : [])

	this.nonempty = function()
	{
		return Q.length != 0
	}

	this.push = function(e)
	{
		Q.push(e)
		for(var x=Q.length-1,p; x>0; x=p)
		{
			p = (x-1)>>1
			if( Q[p][2] <= Q[x][2] )
				break
			var t=Q[p] ; Q[p]=Q[x] ; Q[x]=t
		}
	}

	this.pop = function()
	{
		if( Q.length == 1 )
			return Q.pop()
		var ans=Q[0]; Q[0] = Q.pop()
		for(var x=0,p,p2; x*2+1<Q.length; x=p)
		{
			p=x*2+1, p2=p+1
			if( p2 < Q.length )
				p = (Q[p][2] < Q[p2][2] ? p : p2)
			if( Q[x][2] <= Q[p][2] )
				break
			var t=Q[p] ; Q[p]=Q[x] ; Q[x]=t
		}
		return ans
	}
}

function dijkstra( G, src, veh, is_goal, weight )
{
	if( !weight )
		weight = function(){return 0}

	var prev={}, visited={}
	var Q    = new PriorityQueue([src,src,0])
	while( Q.nonempty() )
	{
		var cnd = Q.pop()
		var n=cnd[0], p=cnd[1], w=cnd[2]
		if( n in prev ) {
			if( visited[n][0] == w ) {
				visited[n][1] ++
				prev[n] = cointoss(1/visited[n][1]) ? p : prev[n];
			}
			continue
		}
		prev[n]    = p
		visited[n] = [w,1]
		if( is_goal(n) && w<100000 )
		{
			var ans = [n]
			while( prev[n] !== src )
				ans.unshift( n = prev[n] )
			return ans
		}
		for each(var e in G[n][veh])
			if( !(e in prev) )
				Q.push( [e,n,w+1+weight(e)] )
	}
	return null
}







function dijkstra_furthest( G, src )
{
	var vislist = []
	var prev={}, visited={}
	var Q    = new PriorityQueue([src,src,0])
	while( Q.nonempty() )
	{
		var cnd = Q.pop()
		var n=cnd[0], p=cnd[1], w=cnd[2]
		if( n in prev ) {
			if( visited[n] == w )
				prev[n].push(p)
			continue
		}
		prev[n]    = [p]
		visited[n] =  w
		vislist.push(n)
		for each(var e in G[n].foot)
			if( !(e in prev) )
				Q.push( [e,n,w+1] )
	}
	return vislist.pop()
}
